" Vim syntax file
" Language:     Csound score
" Maintainer:   Istvan Varga
" Last change:  Jan 6 2003

syn	clear

set	nocompatible
set	autoindent
set	noignorecase
set	showmatch

" score statements (f, t, i etc.)

syn	match	Statement	"^[ \t]*[[:alpha:]]"

" comments

syn	region	Comment	start="/\*" end="\*/"
syn	match	Comment ";.*$"

" backslash

syn	match	Special	"\\$"
syn	match	Special "\\."

" constants

syn	match	Constant	"\<[[:digit:]]\+\(\.[[:digit:]]\+\)\{,1\}\([Ee][+-]\{,1\}[[:digit:]]\+\)\{,1\}\>"
syn	match	Constant	"\".*\""

" include files and macros

syn	match	PreProc	"#"
syn	match	PreProc	"#include"
syn	match	PreProc	"#define"
syn	match	PreProc	"#define[^#]*#"
syn	match	PreProc	"#undef.*$"
syn	match	PreProc	"\$[[:alpha:]][[:alnum:]_]*\(([^()]*)\)\{,1\}\.\{,1\}"

" some useful keyboard shortcuts

" #i: include file

imap	#i	#include ""<CR><UP><HOME><RIGHT><RIGHT><RIGHT><RIGHT><RIGHT><RIGHT><RIGHT><RIGHT><RIGHT><RIGHT>

" #d: define macro

imap	#d	#define  # #<CR><UP><HOME><RIGHT><RIGHT><RIGHT><RIGHT><RIGHT><RIGHT><RIGHT><RIGHT>

" #u: undefine macro

imap	#u	#undef <CR><UP><HOME><RIGHT><RIGHT><RIGHT><RIGHT><RIGHT><RIGHT><RIGHT>

" ``f: insert dummy score

imap	``f	<CR>f 0 3600<CR>e<CR>

